Index: src/org/jboss/ide/eclipse/freemarker/editor/Configuration.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/editor/Configuration.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/editor/Configuration.java	(working copy)
@@ -36,6 +36,8 @@
 import org.eclipse.jface.text.source.ISourceViewer;
 import org.eclipse.ui.editors.text.TextSourceViewerConfiguration;
 import org.jboss.ide.eclipse.freemarker.Constants;
+import org.jboss.ide.eclipse.freemarker.contentassist.CompletionProcessor;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
 
 /**
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
@@ -44,9 +46,9 @@
 	private ColorManager colorManager;
 	private XMLTagScanner xmlTagScanner;
 	private DirectiveScanner directiveScanner;
-	private Editor editor;
+	private SourceEditor editor;
 
-	public Configuration(IPreferenceStore preferenceStore, ColorManager colorManager, Editor editor) {
+	public Configuration(IPreferenceStore preferenceStore, ColorManager colorManager, SourceEditor editor) {
 		super(preferenceStore);
 		this.editor = editor;
 		this.colorManager = colorManager;
Index: src/org/jboss/ide/eclipse/freemarker/editor/MacroHyperlinkDetector.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/editor/MacroHyperlinkDetector.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/editor/MacroHyperlinkDetector.java	(working copy)
@@ -31,14 +31,15 @@
 import org.eclipse.jface.text.hyperlink.IHyperlinkDetector;
 import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
 import org.jboss.ide.eclipse.freemarker.configuration.MacroLibrary;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
 import org.jboss.ide.eclipse.freemarker.model.Item;
 import org.jboss.ide.eclipse.freemarker.model.MacroDirective;
 import org.jboss.ide.eclipse.freemarker.model.MacroInstance;
 
 public class MacroHyperlinkDetector implements IHyperlinkDetector {
 
-	private Editor editor;
-	public MacroHyperlinkDetector(ITextViewer textViewer, Editor editor) {
+	private SourceEditor editor;
+	public MacroHyperlinkDetector(ITextViewer textViewer, SourceEditor editor) {
 		this.editor = editor;
 	}
 
Index: src/org/jboss/ide/eclipse/freemarker/editor/FreemarkerMultiPageEditor.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/editor/FreemarkerMultiPageEditor.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/editor/FreemarkerMultiPageEditor.java	(working copy)
@@ -67,8 +67,11 @@
 import org.jboss.ide.eclipse.freemarker.Messages;
 import org.jboss.ide.eclipse.freemarker.Plugin;
 import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
-import org.jboss.ide.eclipse.freemarker.configuration.ContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
 import org.jboss.ide.eclipse.freemarker.dialogs.ContextValueDialog;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.PreviewEditor;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.PreviewEditorInput;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
 
 /**
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
@@ -77,7 +80,7 @@
 
 	public static final String ID = "org.jboss.ide.eclipse.freemarker.editor.FreemarkerEditor"; //$NON-NLS-1$
 	                                 
-    private Editor vEditor;
+    private SourceEditor vEditor;
     private String text;
     private boolean readOnly = false;
 
@@ -87,15 +90,20 @@
 
     protected void createPages()
     {
-        createPage0();
+        createSourcePage();
         if (!vEditor.isEditorInputReadOnly())
         	createContextPage();
+        createPreviewPage();
     }
 
-    void createPage0()
+    /**
+     * Create Source Page
+     *
+     */
+    void createSourcePage()
     {
         try {
-            vEditor = new Editor();
+            vEditor = new SourceEditor();
             vEditor.init(getEditorSite(), getEditorInput());
             if (readOnly) vEditor.setReadOnly(readOnly);
             int index = addPage(vEditor, getEditorInput());
@@ -107,7 +115,22 @@
         }
     }
 
-    public Editor getEditor () {
+    /**
+     * Create Preview Page
+     *
+     */
+    private void createPreviewPage() {
+        try {
+            int index = addPage(new PreviewEditor(), 
+                    new PreviewEditorInput(vEditor.getFile(), vEditor.getDocument()));
+            setPageText(index, "preview");
+         }
+        catch (PartInitException e) {
+            ErrorDialog.openError(getSite().getShell(), "Error creating nested Preview Editor", null, e.getStatus());
+        }
+    }
+    
+    public SourceEditor getEditor () {
     	return vEditor;
     }
 
@@ -204,11 +227,12 @@
 	public void reloadContextValues () {
 		try {
 			contextValuesTable.removeAll();
-			ContextValue[] values = ConfigurationManager.getInstance(
+			IContextValue[] values = ConfigurationManager.getInstance(
 					vEditor.getFile().getProject()).getContextValues(vEditor.getFile(), false);
 			for (int i=0; i<values.length; i++) {
-				TableItem item = new TableItem(contextValuesTable, SWT.NULL);
-				String[] arr = {values[i].name, values[i].objClass.getName()};
+                IContextValue contextValue = values[i];
+                TableItem item = new TableItem(contextValuesTable, SWT.NULL);
+                String[] arr = {contextValue.getName(),  contextValue.getFirstObjectContext().getName()};
 				item.setText(arr);
 			}
 			editContextValueButton.setEnabled(false);
@@ -254,7 +278,7 @@
 			int index = contextValuesTable.getSelectionIndex();
 			if (index >= 0) {
 				String key = contextValuesTable.getSelection()[0].getText(0);
-				ContextValue value = ConfigurationManager.getInstance(vEditor.getFile().getProject()).getContextValue(key, vEditor.getFile(), false);
+				IContextValue value = ConfigurationManager.getInstance(vEditor.getFile().getProject()).getContextValue(key, vEditor.getFile(), false);
 				ContextValueDialog dialog = new ContextValueDialog(new Shell(), value, vEditor.getFile());
 				if (IDialogConstants.OK_ID == dialog.open()) {
 					reloadContextValues();
@@ -282,8 +306,8 @@
 					boolean confirm = MessageDialog.openConfirm(new Shell(), Messages.FreemarkerMultiPageEditor_CONFIRMATION_TITLE, Messages.FreemarkerMultiPageEditor_CONFIRMATION_TO_DELETE_MESSAGE);
 					if (confirm) {
 						String key = contextValuesTable.getSelection()[0].getText(0);
-						ContextValue value = ConfigurationManager.getInstance(vEditor.getFile().getProject()).getContextValue(key, vEditor.getFile(), false);
-						ConfigurationManager.getInstance(vEditor.getFile().getProject()).removeContextValue(value.name, vEditor.getFile());
+						IContextValue value = ConfigurationManager.getInstance(vEditor.getFile().getProject()).getContextValue(key, vEditor.getFile(), false);
+						ConfigurationManager.getInstance(vEditor.getFile().getProject()).removeContextValue(value.getName(), vEditor.getFile());
 						reloadContextValues();
 					}
 				}
Index: src/org/jboss/ide/eclipse/freemarker/helper/ClassHelper.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/helper/ClassHelper.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/helper/ClassHelper.java	(revision 0)
@@ -0,0 +1,31 @@
+package org.jboss.ide.eclipse.freemarker.helper;
+
+/**
+ * 
+ * Class Helper 
+ *  
+ * @version 1.0.4 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class ClassHelper {
+
+    /**
+     * Return true if class test extends Class base and false otherwise
+     * @param test
+     * @param base
+     * @return
+     */
+    public static boolean instanceOf (Class test, Class base) {
+        if (null == test || null == base) return false;
+        while (null != test) {
+            for (int i=0; i<test.getInterfaces().length; i++) {
+                if (test.getInterfaces()[i].getClass().getName().equals(base.getName())) return true;
+            }
+            if (test.getName().equals(base.getName())) return true;
+            test = test.getSuperclass();
+        }
+        return false;
+    }
+
+}
Index: src/org/jboss/ide/eclipse/freemarker/helper/CompletionProposalComparator.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/helper/CompletionProposalComparator.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/helper/CompletionProposalComparator.java	(revision 0)
@@ -0,0 +1,13 @@
+package org.jboss.ide.eclipse.freemarker.helper;
+
+import java.util.Comparator;
+
+import org.eclipse.jface.text.contentassist.ICompletionProposal;
+
+public class CompletionProposalComparator implements Comparator {
+    
+    public int compare(Object arg0, Object arg1) {
+        return ((ICompletionProposal) arg0).getDisplayString().compareTo(((ICompletionProposal) arg1).getDisplayString());
+    }
+}   
+
Index: src/org/jboss/ide/eclipse/freemarker/helper/CompletionProposalHelper.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/helper/CompletionProposalHelper.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/helper/CompletionProposalHelper.java	(revision 0)
@@ -0,0 +1,243 @@
+package org.jboss.ide.eclipse.freemarker.helper;
+
+import java.beans.BeanInfo;
+import java.beans.IntrospectionException;
+import java.beans.Introspector;
+import java.beans.PropertyDescriptor;
+import java.lang.reflect.Method;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.Date;
+import java.util.Enumeration;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.eclipse.core.resources.IResource;
+import org.eclipse.jface.text.contentassist.CompletionProposal;
+import org.eclipse.jface.text.contentassist.ICompletionProposal;
+import org.jboss.ide.eclipse.freemarker.contentassist.SubCompletionProposal;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.NamedNodeMap;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+
+
+public class CompletionProposalHelper {
+
+    public static ICompletionProposal[] completionProposals (List l) {
+        Collections.sort(l, new CompletionProposalComparator());
+        return (ICompletionProposal[]) l.toArray(new ICompletionProposal[l.size()]);
+    }
+    
+    public static ICompletionProposal[] getProposalsForParentObject (String content, int subOffset, int offset, Object parentObject, IResource file) {
+        if (ContextValueHelper.isClassContextValue(parentObject)) {
+            // Class context
+            Class parentClass = (Class)parentObject;
+            return completionProposals(
+                getMethodCompletionProposals (content, subOffset, offset, parentClass, file));
+        }
+        if (ContextValueHelper.isXMLContextValue(parentObject)) {
+            // XML context
+            Node parentNode = (Node)parentObject;
+            return completionProposals(
+                    getXMLChildrenCompletionProposals (content, subOffset, offset, parentNode, file));
+        }
+        /*if (ContextValueHelper.isDTDContextValue(parentObject)) {
+            // DTD context
+            return completionProposals(
+                    getDTDChildrenCompletionProposals (content, subOffset, offset, parentObject, file));
+        }*/
+        return null;
+    }
+    
+    /* -------------- Class context helper -------------*/
+    
+    private static List getMethodCompletionProposals (String content, int subOffset, int offset, Class parentClass, IResource file) {
+        if (ClassHelper.instanceOf(parentClass, String.class)
+                || ClassHelper.instanceOf(parentClass, Number.class)
+                || ClassHelper.instanceOf(parentClass, Date.class)
+                || ClassHelper.instanceOf(parentClass, Collection.class)
+                || ClassHelper.instanceOf(parentClass, List.class)
+                || ClassHelper.instanceOf(parentClass, Map.class))
+            return null;
+        String prefix = content.substring(1, subOffset);
+        List proposals = new ArrayList();
+        String pUpper = prefix.toUpperCase();
+        try {
+            BeanInfo bi = Introspector.getBeanInfo(parentClass);
+            PropertyDescriptor[] pds = bi.getPropertyDescriptors();
+            for (int i=0; i<pds.length; i++) {
+                PropertyDescriptor pd = pds[i];
+                String propertyName = pd.getName();
+                if (!propertyName.equals("class") && propertyName.toUpperCase().startsWith(pUpper)) {
+                    proposals.add(new CompletionProposal(
+                            propertyName,
+                            offset - subOffset + 1,
+                            content.length()-1,
+                            propertyName.length(),
+                            null, propertyName + " - " + pd.getReadMethod().getReturnType().getName(), null, null));
+                }
+            }
+            for (int i=0; i<parentClass.getMethods().length; i++) {
+                Method m = parentClass.getMethods()[i];
+                String mName = m.getName();
+                if (m.getParameterTypes().length > 0 && mName.startsWith("get") && mName.toUpperCase().startsWith(pUpper)) {
+                    StringBuffer display = new StringBuffer();
+                    display.append(mName);
+                    display.append("(");
+                    for (int j=0; j<m.getParameterTypes().length; j++) {
+                        if (j > 0) display.append(", ");
+                        display.append(m.getParameterTypes()[j].getName());
+                    }
+                    display.append(")");
+                    String actual = mName + "()";
+                    int tLength = actual.length();
+                    if (m.getParameterTypes().length > 0) tLength--;
+                    proposals.add(new CompletionProposal(actual,
+                            offset - subOffset + 1, content.length()-1, tLength,
+                            null, display.toString() + " - " + m.getReturnType().getName(), null, null));
+                }
+            }
+            return proposals;
+        }
+        catch (IntrospectionException e) {
+            return null;
+        }
+    }
+    
+    /* -------------- XML context helper -------------*/
+    
+    private static List getXMLChildrenCompletionProposals (String content, int subOffset, int offset, Node parentNode, IResource file) {
+        List proposals = new ArrayList();
+        try {
+            Element element = null;
+            if (parentNode instanceof Document) {
+                Document document = (Document)parentNode;
+                element = document.getDocumentElement();
+                String elementName = element.getNodeName();
+                proposals.add(getCompletionProposalForElement
+                        (content, subOffset, offset, elementName, "XML Root Element"));             
+            }
+            else {      
+                // Attribute 
+                NamedNodeMap attributes = parentNode.getAttributes();
+                int attributeLength = attributes.getLength();
+                for (int j = 0; j < attributeLength; j++) {
+                    Node attribute = attributes.item(j);
+                    String attributeName = attribute.getNodeName();
+                    attributeName = "@" + attributeName;
+                    proposals.add(new CompletionProposal(
+                            attributeName,
+                            offset - subOffset + 1,
+                            content.length()-1,
+                            attributeName.length(),
+                            null, attributeName + " - XML Attribute" , null, null));
+                }               
+                
+                //Element children
+                NodeList nodeList = parentNode.getChildNodes();
+                int length = nodeList.getLength();
+                Map elementsMap = new HashMap();
+                for (int i=0; i<length; i++) {
+                    Node currentNode = nodeList.item(i);
+                    if (Node.ELEMENT_NODE == currentNode.getNodeType()) {
+                        Element currentElement = (Element)currentNode;
+                        String elementName = currentElement.getNodeName();
+                        if (elementsMap.get(elementName) == null) {
+                            // Element must be added
+                            proposals.add(getCompletionProposalForElement
+                                    (content, subOffset, offset, elementName, "XML Element"));
+                            elementsMap.put(elementName, elementName);
+                   
+                        }
+                    }
+                }
+            }     
+            return proposals;
+        }
+        catch(Exception e) {
+            return null;
+        }
+    }
+    
+    private static ICompletionProposal getCompletionProposalForElement(String content, int subOffset, int offset, String elementName, String description) {
+        boolean removeLeftDot = false;
+        String replacementString = elementName;
+        int replacementOffset = offset - subOffset;
+        if (replacementString.indexOf("-") != -1) {
+            replacementString = "[\"" + replacementString + "\"]";
+            removeLeftDot = true;
+        } 
+        else {
+            replacementOffset++;
+        }
+        return new SubCompletionProposal(
+                replacementString,
+                replacementOffset,
+                content.length()-1,
+                replacementString.length(),
+                null, elementName + " - " + description , null, null, removeLeftDot);
+    }   
+    
+    /* -------------- DTD context helper -------------*/
+    
+    /*private static List getDTDChildrenCompletionProposals (String content, int subOffset, int offset, Object parentObject, IResource file) {
+        List proposals = new ArrayList();
+        try {
+            if (parentObject instanceof DocType) {
+                DocType docType = (DocType)parentObject;
+                for(Enumeration eleList = docType.getRootElements(); eleList.hasMoreElements();)
+                {
+                    String elementName = (String)eleList.nextElement();
+                    proposals.add(getCompletionProposalForElement
+                            (content, subOffset, offset, elementName, "DTD Root Element"));                                 
+                }   
+            }
+            else {      
+                ElementType parentElementType = (ElementType)parentObject; 
+                // Attribute 
+                String[] attributeNames = parentElementType.getAttributeNames();
+                if (attributeNames != null) {
+                    int attributeLength = attributeNames.length;
+                    for (int j = 0; j < attributeLength; j++) {
+                        String attributeName = attributeNames[j];
+                        attributeName = "@" + attributeName;
+                        proposals.add(new CompletionProposal(
+                                attributeName,
+                                offset - subOffset + 1,
+                                content.length()-1,
+                                attributeName.length(),
+                                null, attributeName + " - DTD Attribute" , null, null));
+                    }   
+                }
+                
+                //Element children
+                ElementType[] elementTypes  = parentElementType.getChildren();
+                if (elementTypes != null) {
+                    Map elementsMap = new HashMap();
+                    int length = elementTypes.length;
+                    for (int i=0; i<length; i++) {
+                        ElementType currentDTDElement = elementTypes[i];
+                        String elementName = currentDTDElement.getName();
+                        if (elementsMap.get(elementName) == null) {
+                            // Element must be added
+                            proposals.add(getCompletionProposalForElement
+                                    (content, subOffset, offset, elementName, "DTD Element"));
+                            elementsMap.put(elementName, elementName);
+                   
+                        }
+                    }
+                }
+                
+            }     
+            return proposals;
+        }
+        catch(Exception e) {
+            return null;
+        }
+    }
+    */
+}
Index: src/org/jboss/ide/eclipse/freemarker/helper/ContextValueHelper.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/helper/ContextValueHelper.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/helper/ContextValueHelper.java	(revision 0)
@@ -0,0 +1,198 @@
+package org.jboss.ide.eclipse.freemarker.helper;
+
+import java.io.FileNotFoundException;
+import java.io.IOException;
+
+import javax.xml.parsers.DocumentBuilderFactory;
+import javax.xml.parsers.ParserConfigurationException;
+
+import org.eclipse.core.resources.IFile;
+import org.eclipse.core.runtime.CoreException;
+import org.eclipse.jdt.core.JavaModelException;
+import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
+import org.jboss.ide.eclipse.freemarker.configuration.context.ClassContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.XMLContextValue;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+import org.xml.sax.SAXException;
+
+/**
+ * 
+ * Helper for manage context value (Class, String, XML or DTD). 
+ * 
+ * @version 0.9.15
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class ContextValueHelper {
+    
+    /**
+     * Return true if objectContext is Class and false otherwise.
+     * @param objectContext
+     * @return
+     */
+    public static boolean isClassContextValue(Object objectContext) {
+        return (objectContext != null && 
+                objectContext instanceof Class);
+    }
+    
+    /**
+     * Return true if objectContext is String and false otherwise.
+     * @param objectContext
+     * @return
+     */ 
+    public static boolean isStringContextValue(Object objectContext) {
+        return (objectContext != null && 
+        objectContext instanceof java.lang.String);
+    }
+    
+    /**
+     * Return true if objectContext is XML and false otherwise.
+     * @param objectContext
+     * @return
+     */
+    public static boolean isXMLContextValue(Object objectContext) {
+        return (objectContext != null && objectContext instanceof Node);
+    }
+    
+    /**
+     * Return true if objectContext is DTD and false otherwise.
+     * @param objectContext
+     * @return
+     */
+    /*public static boolean isDTDContextValue(Object objectContext) {
+        return (objectContext != null && 
+            (objectContext instanceof ElementType ||
+             objectContext instanceof DocType));
+    }*/
+    
+    /**
+     * Return child Node Element of parentObject Node with name elementName.
+     * @param parentObject
+     * @param elementName
+     * @return
+     */
+    public static Node getChildNode(Object parentObject, String elementName) {
+        Node parentNode = (Node)parentObject;
+        if (parentNode.getNodeName().equals(elementName))
+            return parentNode;
+        NodeList nodeList = parentNode.getChildNodes();
+        int length = nodeList.getLength();
+        for (int i=0; i<length; i++) {
+            Node currentNode = nodeList.item(i);
+            if (Node.ELEMENT_NODE == currentNode.getNodeType()) {
+                Element currentElement = (Element)currentNode;
+                String currentElementName = currentElement.getNodeName();
+                if (elementName.equals(currentElementName)) {
+                    return currentElement;
+                }
+            }
+        }
+        return null;
+    }
+    
+    /*public static ElementType getChildDTDElement(Object parentObject, String elementName) {
+        if (parentObject instanceof DocType) {
+            DocType docType = (DocType)parentObject;
+            return docType.getElementType(elementName);
+        }
+        if (parentObject instanceof ElementType) {
+            ElementType elementType = (ElementType)parentObject;
+            
+            ElementType[] elementTypes  = elementType.getChildren();
+            if (elementTypes != null) {
+                int length = elementTypes.length;
+                for (int i=0; i<length; i++) {
+                    ElementType currentDTDElement = elementTypes[i];
+                    String currentElementName = currentDTDElement.getName();
+                    if (elementName.equals(currentElementName)) {
+                        return currentDTDElement;
+                    }
+                }
+            }
+        }
+        return null;
+    }*/
+    
+    
+    public static IContextValue getInstanceOfContextValue(ConfigurationManager configurationManager, 
+            int contextType,  String name, 
+            String context1, String context2) throws ClassNotFoundException, JavaModelException, 
+            ParserConfigurationException, SAXException, IOException, CoreException
+    {
+        if (contextType == IContextValue.CLASS) {
+            // Class context value
+            Class objectClass = null;
+            if (context1 != null && context1.length() > 0) {
+                context1 = context1.trim();
+                if (context1.length() > 0) {
+                    objectClass = configurationManager.
+                        getClass(context1);
+                }
+            }
+            if (objectClass == null)
+                return null;
+            Class singularClass = null;
+            if (context2 != null && context2.length() > 0) {
+                context2 = context2.trim();
+                if (context2.length() > 0) {
+                    singularClass = configurationManager.getClass(context2);
+                }
+            }             
+            return new ClassContextValue(name, objectClass, singularClass);
+        }
+        else {
+            if (contextType == IContextValue.STRING) {
+                // String context value
+                return null;
+                //return new StringContextValue(name, context1);
+            }
+            else {
+                if (contextType == IContextValue.XML) {
+                    // XML context value
+                    // 1. Get file ressource
+                    IFile file = configurationManager.getFile(context1);
+                    // 2. Load XML document
+                    Document document = DocumentBuilderFactory.newInstance().
+                        newDocumentBuilder().parse(file.getContents());
+                    return new XMLContextValue(name, context1, document);
+                }
+                else {
+                    /*if (contextType == IContextValue.DTD) {
+                        
+                        // DTD context value
+                        // 1. Get file ressource
+                        IFile file = configurationManager.getFile(context1);
+                        if (!file.exists()) {
+                            throw new FileNotFoundException(context1);
+                        }
+                        
+                        // 2. Load DTD DocType
+                        DTDSource dtdSource = new DTDFileInputStream(context1, file.getContents());
+                        DTDParser parser = new DTDParser();
+                        parser.parse(dtdSource);
+
+                        DocType doctype = parser.getDocType();
+                        return new DTDContextValue(name, context1, doctype);
+                    }*/
+                }
+            }
+        }
+        return null;
+    }
+    
+    /**
+     * Return true if content is start fragment and false otherwise.
+     * eg : if content=doc return true and 
+     * if content=doc.hibernate-mapping return false.
+     * @param content
+     * @return
+     */
+    public static boolean isStartFragment (String content) {
+        return !content.startsWith(".");
+    }    
+
+}
Index: src/org/jboss/ide/eclipse/freemarker/ImageManager.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/ImageManager.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/ImageManager.java	(working copy)
@@ -21,6 +21,10 @@
  */
 package org.jboss.ide.eclipse.freemarker;
 
+import java.net.MalformedURLException;
+import java.net.URL;
+
+import org.eclipse.jface.resource.ImageDescriptor;
 import org.eclipse.swt.graphics.Image;
 
 /**
@@ -38,4 +42,15 @@
 		return Plugin.getDefault().getImage(filename);
 	}
 	
+	public static ImageDescriptor getImageDescriptor(String filename) {
+		if (filename != null)  {
+			try {
+				URL url = new URL(Plugin.getInstance().getDescriptor().getInstallURL(),
+	                  "icons/" + filename);
+	                  return ImageDescriptor.createFromURL(url);
+			} catch (MalformedURLException mue) {
+			}
+		}
+		return null;
+	}
 }
\ No newline at end of file
